package info.textgrid.middleware;

import java.text.ParseException;
import org.junit.BeforeClass;
import org.junit.Ignore;
import org.junit.Test;
import info.textgrid.middleware.oaipmh.DeletedRecordType;
import info.textgrid.middleware.oaipmh.GranularityType;
import info.textgrid.middleware.common.TextGridMimetypes;

/**
 * FIXME: Add documentation how to use this class, use SSH tunneling?
 */
@Ignore
public class OaiPmhTestDH {

  public static OAI_ESClient oaiEsClient;

  private static RecordDelivererDC record;
  private static RecordListDelivererDC recordList;
  private static IdentifierListDelivererDC identifierList;
  private static MetadataFormatListDelivererInterface metadataFormatList =
      new MetadataFormatListDelivererDH();
  private static SetDeliverer setListDARIAH = new SetDeliverer(false, true);

  // private static OpenAireRecord openAireRecord;
  private static RecordDelivererDATACITE recordDATACITE;
  private static OpenAireRecordList openAireRecordList;
  // private static OpenAireIdentifierList openAireIdentifierList;
  private static IdentifierListDelivererDATACITE identifierListDATACITE;

  private DeletedRecordType deletedRecordType = DeletedRecordType.NO;
  private GranularityType granularityType = GranularityType.YYYY_MM_DD_THH_MM_SS_Z;
  private RepIdentification rep = new RepIdentification("DARIAH-DE Repository",
      "https://trep.de.dariah.eu", this.deletedRecordType, "2011-06-11T02:32:40Z",
      this.granularityType, "2.0", "funk@sub.uni-goettingen.de");

  /**
   * FIXME: it should not be necessary to put idiom record variables for a DARIAH test case
   */
  private static RecordDelivererIDIOM recordIDIOM;
  private static RecordListDelivererIDIOM recordListIDIOM;
  private static IdentifierListDelivererIDIOM identifierListIDIOM =
      new IdentifierListDelivererIDIOM(true, false);

  private OAIPMHImpl request =
      new OAIPMHImpl(this.rep, OaiPmhTestDH.record, OaiPmhTestDH.recordIDIOM,
          OaiPmhTestDH.recordDATACITE, OaiPmhTestDH.recordList, OaiPmhTestDH.recordListIDIOM,
          OaiPmhTestDH.openAireRecordList, OaiPmhTestDH.metadataFormatList,
          OaiPmhTestDH.setListDARIAH, OaiPmhTestDH.identifierList, OaiPmhTestDH.identifierListIDIOM,
          // OaiPmhTestDH.openAireIdentifierList);
          OaiPmhTestDH.identifierListDATACITE);

  OAIPMHUtilities settings = new OAIPMHUtilities();

  /**
   * @throws Exception
   */
  @BeforeClass
  public static void setUp() throws Exception {
    int[] ports = new int[] {9202};
    oaiEsClient = new OAI_ESClient("localhost", ports, 100);
    OAI_ESClient.setEsIndex("dariah-public");
    OAI_ESClient.setEsType("metadata");

    record = new RecordDelivererDC(false, true);
    record.setOaiEsClient(oaiEsClient);
    record.setWorkFields(DARIAHConstants.DARIAHFields);
  }

  /**
   * @throws ParseException
   */
  @Test
  public void testGetRequestIdentify() throws ParseException {
    System.out.println("Test for the verb \"Identify\" with succesfull response");
    String r = this.request.getRequest("Identify", "", "", "", "", "", "");
    System.out.println(r);
    System.out.println("-----------------------------------\n");
  }

  /**
   * @throws ParseException
   */
  @Test
  public void testGetRequestGetRecordDariah() throws ParseException {

    OaiPmhTestDH.record.setContributor(DARIAHConstants.CONTRIBUTOR_LIST);
    OaiPmhTestDH.record.setCoverage(DARIAHConstants.COVERAGE_LIST);
    OaiPmhTestDH.record.setCreator(DARIAHConstants.CREATOR_LIST);
    OaiPmhTestDH.record.setDates(DARIAHConstants.DATE_LIST);
    OaiPmhTestDH.record.setDescriptions(DARIAHConstants.DESCRIPTION_LIST);
    OaiPmhTestDH.record.setFormats(DARIAHConstants.FORMAT_LIST);
    OaiPmhTestDH.record.setIdentifiers(DARIAHConstants.IDENTIFIER_LIST);
    OaiPmhTestDH.record.setLanguages(DARIAHConstants.LANGUAGE_LIST);
    OaiPmhTestDH.record.setPublishers(DARIAHConstants.PUBLISHER_LIST);
    OaiPmhTestDH.record.setRelations(DARIAHConstants.RELATIONS_LIST);
    OaiPmhTestDH.record.setRights(DARIAHConstants.RIGHTS_LIST);
    OaiPmhTestDH.record.setSources(DARIAHConstants.SOURCE_LIST);
    OaiPmhTestDH.record.setSubjects(DARIAHConstants.SUBJECT_LIST);
    OaiPmhTestDH.record.setTitles(DARIAHConstants.TITLE_LIST);
    OaiPmhTestDH.record.setTypes(DARIAHConstants.TYPE_LIST);
    OaiPmhTestDH.record.setFields(DARIAHConstants.DARIAHFields);
    OaiPmhTestDH.record.setFormatField(DARIAHConstants.FORMAT);
    OaiPmhTestDH.record.setFormatToFilter("metadata");
    OaiPmhTestDH.record.setDateOfObjectCreation(DARIAHConstants.MODIFIED_FIELD);
    OaiPmhTestDH.record.setRepositoryObjectURIPrefix(DARIAHConstants.ITEM_IDENTIFIER_PREFIX);
    OaiPmhTestDH.record.setIdentifierField("administrativeMetadata.dcterms:identifier");

    System.out.println("Test for the verb \"GetRecord\" for DARIAH with succesfull response");
    String p = this.request.getRequest("GetRecord", "hdl:21.T11991/0000-0005-E1AA-D", "oai_dc", "",
        "", "", "");
    System.out.println(p);
    System.out.println("-----------------------------------\n");
  }

  /**
   * @throws ParseException
   */
  @Test
  public void testListRecordsDariah() throws ParseException {

    OaiPmhTestDH.recordList.setContributors(DARIAHConstants.CONTRIBUTOR_LIST);
    OaiPmhTestDH.recordList.setCoverages(DARIAHConstants.COVERAGE_LIST);
    OaiPmhTestDH.recordList.setCreators(DARIAHConstants.CREATOR_LIST);
    OaiPmhTestDH.recordList.setDates(DARIAHConstants.DATE_LIST);
    OaiPmhTestDH.recordList.setDescriptions(DARIAHConstants.DESCRIPTION_LIST);
    OaiPmhTestDH.recordList.setFormats(DARIAHConstants.FORMAT_LIST);
    OaiPmhTestDH.recordList.setIdentifiers(DARIAHConstants.IDENTIFIER_LIST);
    OaiPmhTestDH.recordList.setLanguages(DARIAHConstants.LANGUAGE_LIST);
    OaiPmhTestDH.recordList.setPublishers(DARIAHConstants.PUBLISHER_LIST);
    OaiPmhTestDH.recordList.setRelations(DARIAHConstants.RELATIONS_LIST);
    OaiPmhTestDH.recordList.setRights(DARIAHConstants.RIGHTS_LIST);
    OaiPmhTestDH.recordList.setSources(DARIAHConstants.SOURCE_LIST);
    OaiPmhTestDH.recordList.setSubjects(DARIAHConstants.SUBJECT_LIST);
    OaiPmhTestDH.recordList.setTitles(DARIAHConstants.TITLE_LIST);
    OaiPmhTestDH.recordList.setTypes(DARIAHConstants.TYPE_LIST);
    OaiPmhTestDH.recordList.setFormatField(DARIAHConstants.FORMAT);
    OaiPmhTestDH.recordList.setDateOfObjectCreation(DARIAHConstants.CREATED);
    OaiPmhTestDH.recordList.setRangeField(DARIAHConstants.MODIFIED_FIELD);
    OaiPmhTestDH.recordList.setDateOfObjectCreation(DARIAHConstants.RANGE_FIELD);
    OaiPmhTestDH.recordList.setIdentifierField(DARIAHConstants.IDENTIFIER);
    OaiPmhTestDH.recordList.setFormatToFilter(TextGridMimetypes.DARIAH_COLLECTION);
    OaiPmhTestDH.recordList.setModifiedField(DARIAHConstants.MODIFIED_FIELD);
    OaiPmhTestDH.recordList
        .setRelationToFurtherMetadataObject("descriptiveMetadata.dc:relation");
    OaiPmhTestDH.recordList.setSearchResponseSize(100);

    String r = this.request.getRequest("ListRecords", "", "oai_dc", "21.T11991/0000-0003-718E-E",
        "", "", "");
    System.out.println(r);
    System.out.println("-----------------------------------\n");
  }

  /**
   * @throws ParseException
   */
  @Test
  public void testListSetsDARIAH() throws ParseException {

    OaiPmhTestDH.setListDARIAH.setFormatField(DARIAHConstants.FORMAT);
    OaiPmhTestDH.setListDARIAH.setFormatToFilter(DARIAHConstants.COLLECTION_MIMETYPE);
    OaiPmhTestDH.setListDARIAH.setIdentifierField(DARIAHConstants.IDENTIFIER);
    OaiPmhTestDH.setListDARIAH
        .setRepositoryObjectURIPrefix(DARIAHConstants.ITEM_IDENTIFIER_PREFIX);
    OaiPmhTestDH.setListDARIAH.setIdentifierField("administrativeMetadata.dcterms:identifier");
    OaiPmhTestDH.setListDARIAH.setSpecField("descriptiveMetadata.dc:title");
    OaiPmhTestDH.setListDARIAH.setSpecFieldPrefix(DARIAHConstants.COLLECTIONREGISTRY_PREFIX);
    String r = this.request.getRequest("ListSets", "", "", "", "", "", "");
    System.out.println(r);
    System.out.println("-----------------------------------\n");
  }

  /**
   * @throws ParseException
   */
  @Test
  public void testListIdentifiersDARIAH() throws ParseException {

    OaiPmhTestDH.identifierList.setFieldForRange(DARIAHConstants.RANGE_FIELD);
    OaiPmhTestDH.identifierList.setIdentifierListFields(DARIAHConstants.IDENTIFIER_LIST_FIELDS);
    OaiPmhTestDH.identifierList
        .setDateOfObjectCreation("administrativeMetadata.dcterms:modified");
    OaiPmhTestDH.identifierList
        .setRepositoryObjectURIPrefix(DARIAHConstants.ITEM_IDENTIFIER_PREFIX);
    OaiPmhTestDH.identifierList.setIdentifierField("administrativeMetadata.dcterms:identifier");
    OaiPmhTestDH.identifierList.setSearchResponseSize("100");
    String r = this.request.getRequest("ListIdentifiers", "", "oai_dc", "", "", "", "");
    System.out.println(r);
    System.out.println("-----------------------------------\n");
  }

}
